package org.rotxo.vmetro;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;


import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

/**
 * Created by Rotxo on 03/11/2015.
 */
public class MetroSQLite extends SQLiteOpenHelper {

    public static final int DATABASE_VERSION = 1;
    public static final String DATABASE_NAME = "bdaMetro.db";

    public Context getContexto() {
        return contexto;
    }

    public Context contexto;




    public MetroSQLite(Context context) {

        super(context, DATABASE_NAME, null, DATABASE_VERSION);
        contexto=context;


    }
    @Override
    public void onCreate(SQLiteDatabase db) {

        Log.w("SQL", "Crea Base de datos sql");
        //creamos la base de datos segun las tablas de metro valencia
        db.execSQL("CREATE TABLE Agency (agency_id	INTEGER,agency_name	TEXT,agency_url	TEXT,agency_timezone	TEXT,agency_lang	TEXT,agency_phone	TEXT, PRIMARY KEY(agency_id))");
        db.execSQL("CREATE TABLE calendar ( service_id	TEXT, monday	NUMERIC, tuesday	NUMERIC, wednesday	NUMERIC, thursday	NUMERIC, friday 	NUMERIC, saturday	NUMERIC, sunday	NUMERIC, start_date	TEXT, end_date	TEXT, PRIMARY KEY(service_id))");
        db.execSQL("CREATE TABLE calendar_dates ( service_id	TEXT, date	TEXT, exception_type	NUMERIC, PRIMARY KEY(date))");
        db.execSQL("CREATE TABLE routes ( route_id	TEXT, agency_id	NUMERIC, route_short_name	NUMERIC, route_long_name	TEXT, route_desc	TEXT, route_type	NUMERIC, route_url	TEXT, route_color	TEXT, route_text_color	TEXT, PRIMARY KEY(route_id))");
        db.execSQL("CREATE TABLE shapes ( shape_id	NUMERIC, shape_pt_lat	TEXT, shape_pt_lon	TEXT, shape_pt_sequence	NUMERIC)");
        db.execSQL("CREATE TABLE stops ( stop_id	NUMERIC, stop_name	TEXT, stop_desc	TEXT, stop_lat	TEXT, stop_lon	TEXT, zone_id	TEXT, stop_url	TEXT, PRIMARY KEY(stop_id))");
        db.execSQL("CREATE TABLE trips ( route_id	TEXT, service_id	TEXT, trip_id	TEXT, trip_headsign	TEXT, block_id	TEXT, shape_id	NUMERIC, PRIMARY KEY(trip_id))");
        db.execSQL("CREATE TABLE stop_times (trip_id	TEXT, arrival_time	TEXT, departure_time	TEXT, stop_id	NUMERIC, stop_sequence	NUMERIC, pickup_type	NUMERIC, drop_off_type	NUMERIC)");
        db.execSQL("CREATE TABLE stops_lineas ( stop_id TEXT, l1 NUMERIC, l2 NUMERIC, l3 NUMERIC, l4 NUMERIC,l5 NUMERIC,l6 NUMERIC, l7 NUMERIC, l8 NUMERIC,l9 numeric,transbordo Numeric, PRIMARY KEY(stop_id))");
        // leemos los archivos y insertamos los datos
        InputStream inputStream=getContexto().getResources().openRawResource(R.raw.agency);
        InsertarCsv(inputStream, "Agency", db);

        inputStream=getContexto().getResources().openRawResource(R.raw.calendar);
        InsertarCsv(inputStream, "calendar",db);

        inputStream=getContexto().getResources().openRawResource(R.raw.calendar_dates);
        InsertarCsv(inputStream, "calendar_dates",db);

        inputStream=getContexto().getResources().openRawResource(R.raw.shapes);
        InsertarCsv(inputStream, "shapes",db);

        inputStream=getContexto().getResources().openRawResource(R.raw.trips);
        InsertarCsv(inputStream, "trips",db);

        inputStream=getContexto().getResources().openRawResource(R.raw.stop_times);
        InsertarCsv(inputStream, "stop_times",db);



        inputStream=getContexto().getResources().openRawResource(R.raw.routes);
        InsertarCsv(inputStream, "routes",db);

        inputStream=getContexto().getResources().openRawResource(R.raw.stops);
        InsertarCsv(inputStream, "stops", db);

        //actualizamos las lineas
        actualizaLineas(db);
        //lineas transbordo  120,33,17,15,25,55,12,123
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=120");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=33");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=17");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=15");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=25");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=55");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=12");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=123");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=115");
                Log.w("SQL", "Tablas Inicializadas");




    }



    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

    }



    ///******************************************pruebas
    ///             lee un archivo csv
    public List Leer(InputStream inputStream){
        List resultList = new ArrayList();
        BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
        try {
            String csvLine;
            Boolean primera=true;
            while ((csvLine = reader.readLine()) != null) {
                String[] row = csvLine.split(",");
                if (primera)
                {
                    primera=false;
                }else
                {
                    resultList.add(row);
                }
            }
        }
        catch (IOException ex) {
            throw new RuntimeException("Error in reading CSV file: "+ex);
        }
        finally {
            try {
                inputStream.close();
            }
            catch (IOException e) {
                throw new RuntimeException("Error while closing input stream: "+e);
            }
        }
        return resultList;
    }

    //Buscamos la lineas y la añadimos a la base de datos para agilizar las consultas posteriormente evitamos 186 consultas por listado
    public void actualizaLineas(SQLiteDatabase db) {



        Cursor cursor = db.rawQuery("select stop_id from stops ", null);

        while (cursor.moveToNext()){
            int parada=cursor.getInt(0);
            String lineas=StopsLineas(parada, db);
            db.execSQL("update stops set stop_desc='"+lineas+"' where stop_id="+parada+"");
        }
        cursor.close();


    }
    //Calcula las lineas de una parada pero con una base de datos abierta
    public String StopsLineas(int stop,SQLiteDatabase db)
    { //este es un puto desastre, los nombres cortos de las paradas no coincide con la realidad,lo único que es correcto es el color asi que sacaremos los numeros de lineas por los colores
        String result="";

        Cursor cursor = db.rawQuery("" +
                "SELECT DISTINCT routes.route_color FROM         stops INNER JOIN stop_times ON stops.stop_id = stop_times.stop_id INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN routes ON trips.route_id = routes.route_id WHERE     (stops.stop_id = "+stop+" AND routes.route_id<>'5RFA'  and routes.route_id<>'5RFD' )", null);
        boolean primero=true;
        String consulta;
        String parada="0";
        while (cursor.moveToNext()){
            if (primero) {
                consulta="insert into  Stops_Lineas  Values (" + stop + ",0,0,0,0,0,0,0,0,0,0)";
                db.execSQL(consulta);
                primero=false;
            }
            String color=cursor.getString(0);

           // 1"FEC601" 2"E60096" 3"DD052C"  5 "008F71""F28D01""CE142B""014A99""8884BF""009870"

            switch (color)
            {
                case "FEC601":
                    parada="1";
                    break;
                case "E60096":
                    parada="2";
                    break;
                case "DD052C":
                    parada="3";
                    break;
                case "014A99":
                    parada="4";
                    break;
                case "008F71":
                    parada="5";
                    break;
                case  "009870":
                    parada="5";
                    break;
                case "8884BF":
                    parada="6";
                    break;
                case "F28D01":
                    parada="7";
                    break;

                case "B8804F":
                    parada="9";
                    break;
                /*
                FEC601	1
E60096	2
B8804F	9
DD052C	3
008F71	5
F28D01	7
CE142B	3	otra
014A99	4
8884BF	6
009870	5	otra

                 */

            }
            if (result.equals("")) {
                consulta="update stops_lineas  set l"+parada+"=1 where stop_id="+stop+"";
                db.execSQL(consulta);
                result = result + " " +parada ;
            }else
            {
                consulta="update Stops_Lineas  set l"+parada+"=1 where stop_id="+stop+"";
                db.execSQL(consulta);
                result = result + " " + parada;
            }
        }
        cursor.close();

        return result;
    }
    ////////////////////////////////////LISTA STOPS
    ///     listada de todas  las paradas en el objeto Stop
    public List<Stops> listaStops() {

        List<Stops> result = new ArrayList<Stops>();
      // Vector<String> result = new Vector<String>();
        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("select stop_id,stop_name,stop_desc,stop_lat,stop_lon,zone_id,stop_url from stops", null);

        while (cursor.moveToNext()){
            Stops st=new Stops();
            st.setStop_id(cursor.getInt(0));
            st.setStop_name(cursor.getString(1));
            st.setStop_desc(cursor.getString(2));
            st.setStop_lat(cursor.getString(3));
            st.setStop_lon(cursor.getString(4));
            st.setZone_id(cursor.getString(5));
            st.setStop_url(cursor.getString(6));
            result.add(st);
        }
        cursor.close();
        db.close();
        return result;
    }
    // Calcula las lineas que tiene una parada
    public String StopsLineas(int stop)
    {
        String result="";
        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("" +
                "SELECT DISTINCT routes.route_short_name FROM         stops INNER JOIN stop_times ON stops.stop_id = stop_times.stop_id INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN routes ON trips.route_id = routes.route_id WHERE     (stops.stop_id = "+stop+")", null);

        while (cursor.moveToNext()){
            String parada=cursor.getString(0);
            if (parada.equals("0"))
                parada="2";
            if (result.equals("")) {
                result = result + " " +parada ;
            }else
            {
                result = result + " " + parada;
            }
    }
        cursor.close();
        db.close();
        return result;
    }

    public Vector<String> StopsLineasLista(int stop)
    {
        Vector<String> lineas=new Vector<>();

        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("" +
                "SELECT DISTINCT routes.route_short_name FROM         stops INNER JOIN stop_times ON stops.stop_id = stop_times.stop_id INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN routes ON trips.route_id = routes.route_id WHERE     (stops.stop_id = "+stop+") and routes.route_id<>'5RFA' AND routes.route_id<>'5RFD'", null);

        while (cursor.moveToNext()){
            String parada=cursor.getString(0);
            if (parada.equals("0"))
                parada="2";
            lineas.add(parada);

        }
        cursor.close();
        db.close();
        return lineas;
    }

    ///  Listado Todas estaciones, pruebas para adaptador
    public Vector<String> listaEstaciones() {

        Vector<String> result = new Vector<String>();
        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("select stop_name from stops order by stop_name", null);

        while (cursor.moveToNext()){
            result.add(cursor.getString(0));
        }
        cursor.close();
        db.close();
        return result;
    }
    ///  Listado Todas las estaciones de una linea, pruebas para adaptador
    public Vector<String> listaEstaciones(String linea) {

        Vector<String> result = new Vector<String>();
        SQLiteDatabase db = getReadableDatabase();
       String consulta="SELECT distinct stops.stop_name FROM stops INNER JOIN stop_times ON stops.stop_id = stop_times.stop_id INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN routes ON trips.route_id = routes.route_id WHERE     (routes.route_short_name ="+linea+") order by stop_name";

        Cursor cursor = db.rawQuery(consulta, null);

        while (cursor.moveToNext()){
            result.add(cursor.getString(0));
        }
        cursor.close();
        db.close();
        return result;
    }
    //Todas la paradas pero en curorso no va en el fragment pero lo dejo
    public Cursor ListadoStops()
    {
        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("select stop_name,zone_id from stops order by stop_name", null);
        db.close();
        return cursor;
    }

    //Listado de paradas para un listview con adaptador propio
    public Vector<StopListado> listaStopListado() {


        Vector<StopListado> result = new Vector<StopListado>();

        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("select stop_name,zone_id,stop_desc,stop_id from stops order by stop_name", null);

        while (cursor.moveToNext()){
            StopListado s=new StopListado();
            s.setTitulo(cursor.getString(0));
            String sub="Zona "+cursor.getString(1)+" Linea "+cursor.getString(2);
            s.setSubtitulo(sub);
            s.setEstacion(cursor.getInt(2));
            result.add(s);
        }
        cursor.close();
        db.close();
        return result;
    }
    //Listado de paradas para un listview con adaptador propio
    public Vector<StopListado> listaStopListado(String linea) {


        Vector<StopListado> result = new Vector<StopListado>();

        SQLiteDatabase db = getReadableDatabase();
        String consulta="SELECT        stop_name,zone_id,stop_desc,stops.stop_id FROM            stops INNER JOIN stops_lineas ON stops.stop_id = stops_lineas.stop_id where stops_lineas.l"+linea+"='1'";

        Cursor cursor = db.rawQuery(consulta, null);


        while (cursor.moveToNext()){

            StopListado s=new StopListado();
            s.setTitulo(cursor.getString(0));
            String sub="Zona "+cursor.getString(1)+" Linea "+cursor.getString(2);
            s.setSubtitulo(sub);
            s.setEstacion(cursor.getInt(2));
            result.add(s);
        }
        cursor.close();
        db.close();
        return result;
    }

    //Listado Horarios para un listview con adaptador propio
    public Vector<HorariosListado> listaHorariosListados(int parada,String dia) {


        Vector<HorariosListado> result = new Vector<HorariosListado>();
        String secuencia=CalendarDaSecuencia(dia);
        SQLiteDatabase db = getReadableDatabase();
        String consulta="SELECT stop_times.arrival_time,  trips.trip_headsign,stop_times.departure_time FROM          stop_times INNER JOIN  trips ON  stop_times.trip_id =  trips.trip_id WHERE     ( stop_times.stop_id = "+parada+")  AND ( trips.service_id = '"+secuencia+"') order by arrival_time";
        Cursor cursor = db.rawQuery(consulta, null);
        while (cursor.moveToNext()){
            HorariosListado h=new HorariosListado();
            h.setLlegada(cursor.getString(0));
            h.setCabecera(cursor.getString(1));
            h.setSalida(cursor.getString(2));
            result.add(h);
        }
        cursor.close();
        db.close();
        return result;
    }
    // Da secuencia segun dia
    public String CalendarDaSecuencia(String dia) {

        String secuencia="000";
        SQLiteDatabase db = getReadableDatabase();

        Cursor cursor = db.rawQuery("Select service_id from calendar where " + dia + "=1 ", null);

        if (cursor != null && cursor.moveToFirst()) {
            secuencia = cursor.getString(0);
        }
        cursor.close();
        db.close();
        return secuencia;


    }

    public Stops UnaParada(String paradaNombre) {

        paradaNombre=paradaNombre.replace("'","''");
        // Vector<String> result = new Vector<String>();
        SQLiteDatabase db = getReadableDatabase();
        String consulta="select stop_id,stop_name,stop_desc,stop_lat,stop_lon,zone_id,stop_url from stops where stop_name='" + paradaNombre + "'";
        Cursor cursor = db.rawQuery(consulta, null);
        Stops st=new Stops();
        while (cursor.moveToNext()){

            st.setStop_id(cursor.getInt(0));
            st.setStop_name(cursor.getString(1));
            st.setStop_desc(cursor.getString(2));
            st.setStop_lat(cursor.getString(3));
            st.setStop_lon(cursor.getString(4));
            st.setZone_id(cursor.getString(5));
            st.setStop_url(cursor.getString(6));

        }
        cursor.close();
        db.close();
        return st;
    }

    public Vector<HorariosTrip> HorariosTripListado(int parada,String dia,String latitud,String longitud,String hora) {


        Vector<HorariosTrip> result = new Vector<HorariosTrip>();
        String secuencia=CalendarDaSecuencia(dia);
        SQLiteDatabase db = getReadableDatabase();
        String consulta="SELECT      stop_times.stop_id, stop_times.trip_id, stop_times.arrival_time, stop_times.departure_time, trips.trip_headsign, trips.route_id, shapes.shape_id, shapes.shape_pt_sequence FROM         stop_times INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN stops ON stop_times.stop_id = stops.stop_id AND trips.trip_headsign <> stops.stop_name INNER JOIN shapes ON trips.shape_id = shapes.shape_id WHERE     (stop_times.stop_id = "+parada+") AND (trips.service_id = '"+secuencia+"') AND (stop_times.arrival_time > '"+hora+"') AND (shapes.shape_pt_lat = '"+latitud+"') AND (shapes.shape_pt_lon = '"+longitud+"') ORDER BY stop_times.arrival_time";
        Cursor cursor = db.rawQuery(consulta, null);
        while (cursor.moveToNext()){
            HorariosTrip h=new HorariosTrip();
            h.setStop_id(cursor.getInt(0));
            h.setTrip_id(cursor.getString(1));
            h.setArrival_time(cursor.getString(2));
            h.setDeparture_time(cursor.getString(3));
            h.setTrip_headsign(cursor.getString(4));
            h.setRoute_id(cursor.getString(5));
            h.setShape_id(cursor.getString(6));
            h.setShape_pt_sequence(cursor.getString(6));
            result.add(h);
        }
        cursor.close();
        db.close();
        return result;
    }
    public HorariosTrip UnHorariosTrip(int parada,String dia,String latitud,String longitud,String hora) {



        String secuencia=CalendarDaSecuencia(dia);
        SQLiteDatabase db = getReadableDatabase();
        String consulta="SELECT      stop_times.stop_id, stop_times.trip_id, stop_times.arrival_time, stop_times.departure_time, trips.trip_headsign, trips.route_id, shapes.shape_id, shapes.shape_pt_sequence, stops.stop_name FROM         stop_times INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN stops ON stop_times.stop_id = stops.stop_id AND trips.trip_headsign <> stops.stop_name INNER JOIN shapes ON trips.shape_id = shapes.shape_id WHERE     (stop_times.stop_id = "+parada+") AND (trips.service_id = '"+secuencia+"') AND (stop_times.arrival_time > '"+hora+"') AND (shapes.shape_pt_lat = '"+latitud+"') AND (shapes.shape_pt_lon = '"+longitud+"') ORDER BY stop_times.arrival_time";
        Cursor cursor = db.rawQuery(consulta, null);

        HorariosTrip h = new HorariosTrip();
        if (cursor != null && cursor.moveToFirst())  {

            h.setStop_id(cursor.getInt(0));
            h.setTrip_id(cursor.getString(1));
            h.setArrival_time(cursor.getString(2));
            h.setDeparture_time(cursor.getString(3));
            h.setTrip_headsign(cursor.getString(4));
            h.setRoute_id(cursor.getString(5));
            h.setShape_id(cursor.getString(6));
            h.setShape_pt_sequence(cursor.getString(7));
            h.setStop_name(cursor.getString(8));
            h.setService_id(secuencia);
        }

        cursor.close();
        db.close();
        return h;
    }



    public Vector<HorariosTrip>  UnHorariosTripLista(int parada,String dia,String latitud,String longitud,String hora)
    {
        Vector<HorariosTrip> result = new Vector<>();
        String secuencia=CalendarDaSecuencia(dia);
        SQLiteDatabase db = getReadableDatabase();
        String consulta="SELECT      stop_times.stop_id, stop_times.trip_id, stop_times.arrival_time, stop_times.departure_time, trips.trip_headsign, trips.route_id, shapes.shape_id, shapes.shape_pt_sequence, stops.stop_name FROM         stop_times INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN stops ON stop_times.stop_id = stops.stop_id AND trips.trip_headsign <> stops.stop_name INNER JOIN shapes ON trips.shape_id = shapes.shape_id WHERE     (stop_times.stop_id = "+parada+") AND (trips.service_id = '"+secuencia+"') AND (stop_times.arrival_time > '"+hora+"') AND (shapes.shape_pt_lat = '"+latitud+"') AND (shapes.shape_pt_lon = '"+longitud+"') ORDER BY stop_times.arrival_time";
        Cursor cursor = db.rawQuery(consulta, null);
        while (cursor.moveToNext()){
            HorariosTrip h= new HorariosTrip();
            h.setStop_id(cursor.getInt(0));
            h.setTrip_id(cursor.getString(1));
            h.setArrival_time(cursor.getString(2));
            h.setDeparture_time(cursor.getString(3));
            h.setTrip_headsign(cursor.getString(4));
            h.setRoute_id(cursor.getString(5));
            h.setShape_id(cursor.getString(6));
            h.setShape_pt_sequence(cursor.getString(7));
            h.setStop_name(cursor.getString(8));
            h.setService_id(secuencia);
            result.add(h);
        }
        cursor.close();
        db.close();

      return result;

    }
    public HorariosTrip UnHorariosTripxTren(int parada,String servicio,String hora,String tren)
    {

        HorariosTrip t= new HorariosTrip();
        SQLiteDatabase db = getReadableDatabase();
        String consulta="SELECT     stops.stop_id, stops.stop_name, trips.trip_id, trips.service_id, trips.route_id, trips.trip_headsign, stop_times.arrival_time, stop_times.departure_time FROM         stop_times INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN stops ON stop_times.stop_id = stops.stop_id WHERE     (stop_times.stop_id = "+parada+") AND (trips.service_id = '"+servicio+"') AND (stop_times.arrival_time > '"+hora+"') AND (stop_times.trip_id = '"+tren+"') ORDER BY  arrival_time";
        Cursor cursor = db.rawQuery(consulta, null);
        if (cursor != null && cursor.moveToFirst()) {
            t.setStop_id(cursor.getInt(0));
            t.setStop_name(cursor.getString(1));
            t.setTrip_id(cursor.getString(2));
            t.setService_id(cursor.getString(3));
            t.setRoute_id(cursor.getString(4));
            t.setTrip_headsign(cursor.getString(5));
            t.setArrival_time(cursor.getString(6));
            t.setDeparture_time(cursor.getString(7));
        }
        cursor.close();
        db.close();

        return t;

    }
    public HorariosTrip UnHorariosTripxTrenTrans(int parada,String servicio,String tren,String linea1,String linea2)
    {

        HorariosTrip t= new HorariosTrip();
        SQLiteDatabase db = getReadableDatabase();
        String consulta="Select stops_1.stop_id, stops_1.stop_name, trips.trip_id, trips.service_id, trips.route_id, trips.trip_headsign, stop_times.arrival_time, stop_times.departure_time FROM            stops INNER JOIN stop_times ON stops.stop_id = stop_times.stop_id INNER JOIN trips ON stop_times.trip_id = trips.trip_id INNER JOIN shapes ON trips.shape_id = shapes.shape_id INNER JOIN stops AS stops_1 ON shapes.shape_pt_lon = stops_1.stop_lon AND shapes.shape_pt_lat = stops_1.stop_lat INNER JOIN stops_lineas ON stops_1.stop_id = stops_lineas.stop_id WHERE   (stops_1.stop_id != "+parada+") and       (stops.stop_id = "+parada+") AND (stop_times.trip_id = '"+tren+"') and (stops_lineas.transbordo=1) and ("+linea1+") and  ("+linea2+")  ORDER BY shapes.shape_pt_sequence";
        Cursor cursor = db.rawQuery(consulta, null);
        if (cursor != null && cursor.moveToFirst()) {
            t.setStop_id(cursor.getInt(0));
            t.setStop_name(cursor.getString(1));
            t.setTrip_id(cursor.getString(2));
            t.setService_id(cursor.getString(3));
            t.setRoute_id(cursor.getString(4));
            t.setTrip_headsign(cursor.getString(5));
            t.setArrival_time(cursor.getString(6));
            t.setDeparture_time(cursor.getString(7));
        }

        cursor.close();
        db.close();

        return t;

    }




    public Stops UnaParadaXLinea(String linea1,String linea2) {




        String consulta="SELECT        stops.stop_id, stops.stop_name, stops.stop_desc, stops.stop_lat, stops.stop_lon, stops.zone_id, stops.stop_url FROM            stops INNER JOIN stops_lineas ON stops.stop_id = stops_lineas.stop_id  where transbordo='1' and ( "+linea1+") and ("+linea2+")    ";
        if (linea1.contentEquals( "l4='1'or l6='1'"))
            consulta="SELECT        stops.stop_id, stops.stop_name, stops.stop_desc, stops.stop_lat, stops.stop_lon, stops.zone_id, stops.stop_url FROM            stops INNER JOIN stops_lineas ON stops.stop_id = stops_lineas.stop_id  where transbordo='1' and stops_lineas.stop_id='12'";

        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery(consulta, null);
        Stops st = new Stops();
        if (cursor != null && cursor.moveToFirst()) {



            st.setStop_id(cursor.getInt(0));
            st.setStop_name(cursor.getString(1));
            st.setStop_desc(cursor.getString(2));
            st.setStop_lat(cursor.getString(3));
            st.setStop_lon(cursor.getString(4));
            st.setZone_id(cursor.getString(5));
            st.setStop_url(cursor.getString(6));
        }

     db.close();
        cursor.close();

        return st;
    }


    //////////////////////////////////INSERTAR ARCHIVOS CSV
    ///
    public void InsertarCsv(InputStream inputStream,String tabla,SQLiteDatabase db){


        BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
        try {
            String csvLine;
            Boolean primera=true;
            while ((csvLine = reader.readLine()) != null) {
                csvLine=csvLine.replace("'","''");
                String[] row = csvLine.split(",");
                if (primera)
                {
                    primera=false;
                }else
                {
                    switch (tabla)
                    {
                        case "Agency":
                            db.execSQL("INSERT INTO Agency VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"' )");
                            break;
                        case "calendar":
                            db.execSQL("INSERT INTO calendar VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','"+row[6]+"','"+row[7]+"','"+row[8]+"','"+row[9]+"' )");
                            break;
                        case "calendar_dates":
                            db.execSQL("INSERT INTO calendar_dates VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"')");
                            break;
                        case "routes":
                            db.execSQL("INSERT INTO routes VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','"+row[6]+"','"+row[7]+"',' ' )");
                            break;
                        case "shapes":
                            db.execSQL("INSERT INTO shapes VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"' )");
                            break;
                        case "stops":

                            db.execSQL("INSERT INTO stops VALUES ('"+row[0]+"','"+row[1]+"','"+row[3]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','' )");
                            break;
                        case "trips":
                            db.execSQL("INSERT INTO trips VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"' )");
                            break;
                        case "stop_times":
                            db.execSQL("INSERT INTO stop_times VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','"+row[6]+"' )");
                            break;

                    }
                }
            }
        }
        catch (IOException ex) {
            throw new RuntimeException("Error in reading CSV file: "+ex);
        }
        finally {
            try {
                inputStream.close();

            }
            catch (IOException e) {
                throw new RuntimeException("Error while closing input stream: "+e);
            }
        }

    }

    //////////////////////////////////INSERTAR ARCHIVOS CSV
    ///
    public void ActualizaCsv(InputStream inputStream,String tabla){

        SQLiteDatabase db = getWritableDatabase();
        BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
        try {
            String csvLine;
            Boolean primera=true;
            while ((csvLine = reader.readLine()) != null) {
                csvLine=csvLine.replace("'","''");
                String[] row = csvLine.split(",");
                if (primera)
                {
                    primera=false;
                }else
                {
                    switch (tabla)
                    {
                        case "Agency":
                            db.execSQL("INSERT INTO Agency VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"' )");
                            break;
                        case "calendar":
                            db.execSQL("INSERT INTO calendar VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','"+row[6]+"','"+row[7]+"','"+row[8]+"','"+row[9]+"' )");
                            break;
                        case "calendar_dates":
                            db.execSQL("INSERT INTO calendar_dates VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"')");
                            break;
                        case "routes":
                            db.execSQL("INSERT INTO routes VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','"+row[6]+"','"+row[7]+"',' ' )");
                            break;
                        case "shapes":
                            db.execSQL("INSERT INTO shapes VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"' )");
                            break;
                        case "stops":

                            db.execSQL("INSERT INTO stops VALUES ('"+row[0]+"','"+row[1]+"','"+row[3]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"','' )");
                            break;
                        case "trips":
                            db.execSQL("INSERT INTO trips VALUES ('"+row[0]+"','"+row[1]+"','"+row[2]+"','"+row[3]+"','"+row[4]+"','"+row[5]+"' )");
                            break;
                        case "stop_times":
                            db.execSQL("INSERT INTO stop_times VALUES ('" + row[0] + "','" + row[1] + "','" + row[2] + "','" + row[3] + "','" + row[4] + "','" + row[5] + "','" + row[6] + "' )");

                            break;

                    }
                }
            }
            db.close();
        }
        catch (IOException ex) {
            throw new RuntimeException("Error in reading CSV file: "+ex);
        }
        finally {
            try {
                inputStream.close();

            }
            catch (IOException e) {
                throw new RuntimeException("Error while closing input stream: "+e);
            }
        }

    }
    public boolean VaciaBda() {





        SQLiteDatabase db = getWritableDatabase();

        db.execSQL("delete from Agency");
        db.execSQL("delete from calendar");
        db.execSQL("delete from calendar_dates");
        db.execSQL("delete from routes");
        db.execSQL("delete from shapes");
        db.execSQL("delete from stops");
        db.execSQL("delete from trips");
        db.execSQL("delete from stop_times");
        db.execSQL("delete from stops_lineas");


        db.close();


        return true;
    }
    public boolean VaciaBda(String tabla) {





        SQLiteDatabase db = getWritableDatabase();

        db.execSQL("delete from "+tabla+"");



        db.close();


        return true;
    }
    public boolean ActualizaDatos()
    {
        SQLiteDatabase db = getWritableDatabase();
        //actualizamos las lineas
        actualizaLineas(db);
        //lineas transbordo  120,33,17,15,25,55,12,123
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=120");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=33");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=17");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=15");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=25");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=55");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=12");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=123");
        db.execSQL("update stops_lineas  set transbordo=1 where stop_id=115");
        db.close();
        return true;
    }
    public String listaCalendar(String servicio) {


        String fecha="";
        SQLiteDatabase db = getReadableDatabase();
        Cursor cursor = db.rawQuery("select end_date from calendar where service_id='"+servicio+"'", null);

        if (cursor != null && cursor.moveToFirst()) {
            fecha=cursor.getString(0);
        }
        cursor.close();
        db.close();
        return  fecha;
    }
    public boolean CompruebaCalendario(InputStream inputStream){
        boolean ok=true;

        BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
        try {
            String csvLine;
            Boolean primera=true;
            while ((csvLine = reader.readLine()) != null) {
                String[] row = csvLine.split(",");
                if (primera)
                {
                    primera=false;
                }else
                {
                    String fechaorigen=listaCalendar(row[0]);
                    if (!fechaorigen.equals(row[9]))
                    {
                        ok=false;
                    }
                }
            }
        }
        catch (IOException ex) {
            throw new RuntimeException("Error in reading CSV file: "+ex);
        }
        finally {
            try {
                inputStream.close();
            }
            catch (IOException e) {
                throw new RuntimeException("Error while closing input stream: "+e);
            }
        }
        return ok;
    }



}
