package org.rotxo.vmetro;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import java.util.Vector;

/**
 * Created by Rotxo on 11/11/2015.
 */


public class MuestraRuta extends Activity {

    ListAdapter listadapter;
    Vector<HorariosTrip> horariostrip;
    Vector<String> lineasOrigen;
    Vector<String> lineasDestino;
    ListView listView;


    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ruta);
        Bundle extras=getIntent().getExtras();
        String origen=extras.getString(Comunes.ORIGEN);
        String destino=extras.getString(Comunes.DESTINO);
        String hora=extras.getString(Comunes.HORA);
        String trip_id=extras.getString(Comunes.TRIP);


        listView = (ListView) findViewById(R.id.listViewRuta);

        if(hora.length()==4)
            hora="0"+hora;
        if ((origen!=null)&&(destino!=null)&&(hora!=null))
          CalculaRuta(origen, destino, hora);



    }
    private void CalculaRuta(String EstaOrigen,String EstaDestino,String hora)
    {
        MetroSQLite m=new MetroSQLite(this );
        lineasOrigen=new Vector<>();
        lineasDestino=new Vector<>();
        Stops or=new Stops();
        Stops des=new Stops();
        or=m.UnaParada(EstaOrigen);
        des=m.UnaParada(EstaDestino);
        lineasOrigen=m.StopsLineasLista(or.getStop_id());
        lineasDestino=m.StopsLineasLista(des.getStop_id());

        String dia=Comunes.ObtnenerDia();
        HorariosTrip ti=new HorariosTrip();
        HorariosTrip inicio;
        HorariosTrip fin;
        horariostrip = new Vector<>();
        do {


            if (MismaLinea()) {
                //saco la hora

                inicio = m.UnHorariosTrip(or.getStop_id(), dia, des.getStop_lat(), des.getStop_lon(), hora);

                //final
                //int parada,String servicio,String hora,String tren
                fin = m.UnHorariosTripxTren(des.getStop_id(), inicio.getService_id(), hora, inicio.getTrip_id());

                if (fin.getStop_name() ==null) {
                    Vector<HorariosTrip> listatrenes=m.UnHorariosTripLista(or.getStop_id(), dia, des.getStop_lat(), des.getStop_lon(), hora);
                    int x=listatrenes.size();
                    if (x!=0) {
                        for (int i = 0; i <= listatrenes.size() - 1; i++) {


                            //int parada,String servicio,String hora,String tren
                            fin = m.UnHorariosTripxTren(des.getStop_id(), listatrenes.get(i).getService_id(), hora, listatrenes.get(i).getTrip_id());
                            fin.setTipo("LLegada a " + fin.getStop_name());
                            if (fin.getStop_name() != null) {

                                inicio = listatrenes.get(i);
                                inicio.setTipo("Partida de " + listatrenes.get(i).getStop_name());
                                break;
                            }
                        }
                    }else
                    {
                        //estamos en la misma linea, pero necesitamos un empalme

                    }


                }
                inicio.setTipo("Partida de " + inicio.getStop_name());
                horariostrip.add(inicio);
                fin.setTipo("LLegada a " + fin.getStop_name());
                if (fin.getStop_name()!=null)
                 horariostrip.add(fin);
                break;

            } else {
                //Salida
                //saco la linea

                String linea1 = LineasConsulta(lineasOrigen);

                String linea2 =LineasConsulta(lineasDestino) ;
                Stops tmp = m.UnaParadaXLinea(linea1, linea2);
                //sacamos la primera ruta da igual a que parte de la linea

                inicio = m.UnHorariosTrip(or.getStop_id(), dia, tmp.getStop_lat(), tmp.getStop_lon(), hora);




                //final

                //obtengo la parada del empalme siguiendo la secuencia de la ruta
                fin = m.UnHorariosTripxTrenTrans(inicio.getStop_id(), inicio.getService_id(), inicio.getTrip_id(), linea1, linea2);
                //los horarios no son correcto , los obtenemo
                fin = m.UnHorariosTripxTren(fin.getStop_id(), inicio.getService_id(), hora, inicio.getTrip_id());



                if (fin.getStop_name() !=null) { // HA ENCONTRADO LA RUTA
                    inicio.setTipo("Partida de " + or.getStop_name());
                    horariostrip.add(inicio);
                    inicio=fin;
                    inicio.setTipo("Llegada a " + inicio.getStop_name());
                    horariostrip.add(inicio);
                    //cambiamos el origen
                    or = m.UnaParada(fin.getStop_name());
                    hora = fin.getArrival_time();

                    lineasOrigen = m.StopsLineasLista(or.getStop_id());

                }else
                {
                    //SI NO HA ENCONTRADO LA RUTA, ES QUE VAMOS EN EL OTRO SENTIDO
                    Vector<HorariosTrip> listatrenes=m.UnHorariosTripLista(or.getStop_id(), dia, tmp.getStop_lat(), tmp.getStop_lon(), hora);
                    int x=listatrenes.size();
                    if (x!=0) {
                        for (int j = 0; j <= listatrenes.size() - 1; j++) {


                            //int parada,String servicio,String hora,String tren
                            fin = m.UnHorariosTripxTren(tmp.getStop_id(), listatrenes.get(j).getService_id(), hora, listatrenes.get(j).getTrip_id());

                            if (fin.getStop_name() != null) {

                                inicio = listatrenes.get(j);
                                inicio.setTipo("Partida de " + listatrenes.get(j).getStop_name());
                                horariostrip.add(inicio);
                                fin.setTipo("LLegada a " + fin.getStop_name());
                                horariostrip.add(fin);
                                or = m.UnaParada(fin.getStop_name());
                                hora = fin.getArrival_time();
                                lineasOrigen=m.StopsLineasLista(or.getStop_id());
                                break;
                            }
                        }
                    }




                }



            }


        }while (des.getStop_id()!=fin.getStop_id());

        listadapter = new AdaptadoTripListado(this, horariostrip);
        listView.setAdapter(listadapter);



    }
    private String LineasConsulta( Vector<String> lineas)
    {
        String linea="";
        for (int i=0;i<=lineas.size()-1;i++) {

            if (i==0)
            {
                linea="l"+lineas.get(i)+"='1'";
            }else
            {
                linea=linea+"or l"+lineas.get(i)+"='1'";
            }
        }
        return linea;
    }
    private boolean MismaLinea()
    {
        boolean ok=false;
        for (int i=0;i<=lineasOrigen.size()-1;i++)
        {
            for (int j=0;j<=lineasDestino.size()-1;j++)
            {
                if (lineasOrigen.get(i).equals(lineasDestino.get(j)))
                {
                    ok=true;
                    break;
                }
            }
        }
        return ok;

    }
}

