package org.rotxo.vmetro;

import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ListView;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

/**
 * Created by Rotxo on 25/10/2015.
 */
public class TabAcercaDe extends Fragment implements View.OnClickListener {

    Button btnactualiza;


    public static final int progress_bar_type = 0;

    private static String FICHERO =System.getenv("SECONDARY_STORAGE") + "/Android/data/org.rotxo.vmetro/files/google_transit.zip";
    File ruta = new File(System.getenv("SECONDARY_STORAGE") + "/Android/data/org.rotxo.vmetro/files/");
    private static String ruta2=System.getenv("SECONDARY_STORAGE") + "/Android/data/org.rotxo.vmetro/files/";
    private static String file_url = "http://www.metrovalencia.es/google_transit_feed/google_transit.zip";
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View v =  inflater.inflate(R.layout.tabacercade, container, false);
        btnactualiza = (Button)v.findViewById(R.id.btnActualiza);
        btnactualiza.setOnClickListener(this);
        return v;
    }
    @Override
    public void onClick(View v) {


        new DescargaFichero().execute(file_url);



    }



    class DescargaFichero extends AsyncTask<String, String, String> {               //----------------------------clase DescargaFichero

        private ProgressDialog dilogDescarga;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            dilogDescarga = new ProgressDialog(getActivity());
            dilogDescarga.setMessage("Descargando google transit..");
            dilogDescarga.setIndeterminate(false);
            dilogDescarga.setMax(100);
            dilogDescarga.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
            dilogDescarga.setCancelable(true);
            dilogDescarga.show();
            if ( !compruebaEstado()) {
                FICHERO = "/sdcard/google_transit.zip";
                ruta2 = "/sdcard/";
            }
        }


        @Override
        protected String doInBackground(String... f_url) {
            int count;
            try {
                URL url = new URL(f_url[0]);
                URLConnection conection = url.openConnection();
                conection.connect();
                int lenghtOfFile = conection.getContentLength();
                InputStream input = new BufferedInputStream(url.openStream(), 8192);

                OutputStream output = new FileOutputStream(FICHERO);


                byte data[] = new byte[1024];

                long total = 0;

                while ((count = input.read(data)) != -1) {
                    total += count;
                    publishProgress(""+(int)((total*100)/lenghtOfFile));


                    output.write(data, 0, count);
                }


                output.flush();


                output.close();
                input.close();

            } catch (Exception e) {
                Log.e("Error: ", e.getMessage());
            }

            return null;
        }
        protected boolean compruebaEstado()
        {
            Boolean ok=true;
            String stadoSD = Environment.getExternalStorageState();
            if (stadoSD.equals(Environment.MEDIA_MOUNTED)) {
                ok=true;

                if (!ruta.exists()) {
                    ruta.mkdirs();
                }

                if (stadoSD.equals(Environment.MEDIA_MOUNTED_READ_ONLY)) {
                    ok = false;

                }

            }else {
                ok=false;

            }


            return ok;
        }


        protected void onProgressUpdate(String... progress) {

            dilogDescarga.setProgress(Integer.parseInt(progress[0]));
        }


        @Override
        protected void onPostExecute(String file_url) {

            dilogDescarga.dismiss();

            if(Descomprimir(ruta2,"google_transit.zip"))

            {
                new ActualizaBda().execute(ruta2);
            }
        }
        private boolean Descomprimir(String path, String zipname)
        {
            InputStream is;
            ZipInputStream zis;
            try
            {
                is = new FileInputStream(path + zipname);
                zis = new ZipInputStream(new BufferedInputStream(is));
                ZipEntry ze;

                while((ze = zis.getNextEntry()) != null)
                {
                    ByteArrayOutputStream baos = new ByteArrayOutputStream();
                    byte[] buffer = new byte[1024];
                    int count;

                    String filename = ze.getName();
                    FileOutputStream fout = new FileOutputStream(path + filename);


                    while((count = zis.read(buffer)) != -1)
                    {
                        baos.write(buffer, 0, count);
                        byte[] bytes = baos.toByteArray();
                        fout.write(bytes);
                        baos.reset();
                    }

                    fout.close();
                    zis.closeEntry();
                }

                zis.close();
            }
            catch(IOException e)
            {
                e.printStackTrace();
                return false;
            }

            return true;
        }

    }  //---------------------FIN CLASE DescargaFichero

    class ActualizaBda extends AsyncTask<String, String, String> {               //----------------------------clase ActualizaBda

        private ProgressDialog dilogActualiza;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            dilogActualiza = new ProgressDialog(getActivity());
            dilogActualiza.setMessage("Actualizando la Base de Datos...");
            dilogActualiza.setIndeterminate(false);
            dilogActualiza.setMax(100);
            dilogActualiza.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
            dilogActualiza.setCancelable(true);
            dilogActualiza.show();

        }


        @Override
        protected String doInBackground(String... f_url) {

            try {

                MetroSQLite m=new MetroSQLite(getContext() );
                InputStream inputStream;

                inputStream=new FileInputStream(ruta2+"//calendar.txt");
                boolean igual =m.CompruebaCalendario(inputStream);
                if (igual) { //si son los mismos datos actualizamos las incidencias

                    m.VaciaBda("calendar_dates");
                    publishProgress("50");

                    inputStream = new FileInputStream(ruta2 + "//calendar_dates.txt");
                    m.ActualizaCsv(inputStream, "calendar_dates");
                    inputStream.close();
                    Log.e("Actualiza", "CalendarDates");
                    publishProgress("100");
                }else {//si no actualizamos todo

                    m.VaciaBda();
                    publishProgress("10");


                    inputStream = new FileInputStream(ruta2 + "//agency.txt");
                    m.ActualizaCsv(inputStream, "Agency");
                    publishProgress("20");
                    inputStream.close();
                    Log.e("Actualiza", "Agency");
                    inputStream = new FileInputStream(ruta2 + "//calendar.txt");
                    m.ActualizaCsv(inputStream, "calendar");
                    inputStream.close();
                    Log.e("Actualiza", "Calendar");
                    publishProgress("30");
                    inputStream = new FileInputStream(ruta2 + "//calendar_dates.txt");
                    m.ActualizaCsv(inputStream, "calendar_dates");
                    inputStream.close();
                    Log.e("Actualiza", "CalendarDates");
                    publishProgress("40");
                    inputStream = new FileInputStream(ruta2 + "//routes.txt");
                    m.ActualizaCsv(inputStream, "routes");
                    inputStream.close();
                    Log.e("Actualiza", "routes");
                    publishProgress("50");
                    inputStream = new FileInputStream(ruta2 + "//shapes.txt");
                    m.ActualizaCsv(inputStream, "shapes");
                    Log.e("Actualiza", "Shapes");
                    inputStream.close();
                    publishProgress("60");
                    inputStream = new FileInputStream(ruta2 + "//stops.txt");
                    m.ActualizaCsv(inputStream, "stops");
                    inputStream.close();
                    Log.e("Actualiza", "Stops");
                    publishProgress("70");
                    inputStream = new FileInputStream(ruta2 + "//trips.txt");
                    m.ActualizaCsv(inputStream, "trips");
                    inputStream.close();
                    Log.e("Actualiza", "Trips");
                    publishProgress("80");
                    inputStream = new FileInputStream(ruta2 + "//stop_times.txt");
                    m.ActualizaCsv(inputStream, "stop_times");
                    inputStream.close();
                    publishProgress("90");
                    Log.e("Actualiza", "Stop Times");
                    m.ActualizaDatos();
                    Log.e("Actualiza", "Datos");
                    publishProgress("100");
                }


            } catch (Exception e) {
                Log.e("Error: ", e.getMessage());
            }

            return null;
        }



        protected void onProgressUpdate(String... progress) {

            dilogActualiza.setProgress(Integer.parseInt(progress[0]));
        }


        @Override
        protected void onPostExecute(String file_url) {

            dilogActualiza.dismiss();


        }


    }  //---------------------FIN CLASE DescargaFichero


}