package org.rotxo.vmetro;

import android.app.Activity;
import android.app.FragmentManager;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentTransaction;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;


import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;


import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

import java.util.List;


/**
 * Created by Rotxo on 25/10/2015.
 */
public class TabMapa extends Fragment {

    public GoogleMap mapa;
    private SupportMapFragment fragment;
    List<Stops> lista;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        MetroSQLite m=new MetroSQLite(this.getContext() );
        lista=m.listaStops();


    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        return inflater.inflate(R.layout.tabmapa, container, false);

    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        android.support.v4.app.FragmentManager fm = getChildFragmentManager();
        fragment = (SupportMapFragment) fm.findFragmentById(R.id.mapa);
        if (fragment == null) {
            fragment = SupportMapFragment.newInstance();
            fm.beginTransaction().replace(R.id.mapa, fragment).commit();
        }
    }

    @Override
    public void onResume() {
        super.onResume();
        if (mapa == null) {
            mapa = fragment.getMap();
            mapa.setMapType(GoogleMap.MAP_TYPE_NORMAL);
            mapa.setMyLocationEnabled(true);
            MarcarPosiciones();
            moveCamera();
        }
    }
    public void MarcarPosiciones()
    {

        for (int i=0;i<=lista.size()-1;i++)
        {
            float latitud=Float.parseFloat(lista.get(i).getStop_lat());
            float longitud=Float.parseFloat(lista.get(i).getStop_lon());
            LatLng pos = new LatLng(latitud ,longitud);
            mapa.addMarker(new MarkerOptions()
                    .position(pos)
                    .title(lista.get(i).getStop_name())
                    .snippet("Zona "+lista.get(i).getZone_id()+ " Linea "+lista.get(i).getStop_desc())
                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.ic_tren))
                    .anchor(0.5f, 0.5f)
            );
        }
    }
    public void moveCamera() {

        float lat = (float) 39.4671859741;// (float) (mejorLocaliz.getLatitude());
        float lng = (float)-0.3773750067; //(mejorLocaliz.getLongitude());
        LatLng latLng = new LatLng(lat, lng);

        CameraPosition cameraPosition = new CameraPosition.Builder()
                .target(latLng)      // seteamos el centro del mapa en la posicion actual
                .zoom(13)                   // configuramos el zoom
                .tilt(30)                   // configuramos el angulo de la camara a 30 grados
                .build();                   // Una vez seteado los parametros, construimos el objetos


        // ubicamos nuestra posicion en el mapa centrado
        mapa.animateCamera(CameraUpdateFactory.newCameraPosition(cameraPosition));




    }

}