package org.rotxo.vmetro;

import android.content.Intent;
import android.os.Bundle;

import android.os.Handler;
import android.os.Message;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.SpinnerAdapter;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;


/**
 * Created by Rotxo on 25/10/2015.
 */
public class TabRuta extends Fragment   {

    SpinnerAdapter listadapter;

    ImageView btnhora;
    TextView texHora;
    Spinner spinnerO;
    Spinner spinnerD;
    private static int timeHour = Calendar.getInstance().get(Calendar.HOUR);
    private static int timeMinute = Calendar.getInstance().get(Calendar.MINUTE);
    Vector<String> lista;
    Vector<HorariosTrip> horariostrip;
    Button btnahora;
    Button btnhorarios;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View v =  inflater.inflate(R.layout.tabruta, container, false);
        btnhora =(ImageView) v.findViewById(R.id.btnHora);
        texHora =(TextView) v.findViewById(R.id.textHora);
         btnahora=(Button) v.findViewById(R.id.buttonAhora);
        btnhorarios=(Button) v.findViewById(R.id.buttonHorarios);

        View.OnClickListener listenerHora= new View.OnClickListener() {
            public void onClick(View view) {
                Bundle bundle = new Bundle();
                bundle.putInt(Comunes.HOUR, timeHour);
                bundle.putInt(Comunes.MINUTE, timeMinute);
                DialogoHora fragment = new DialogoHora(new MiHandlerHora());
                fragment.setArguments(bundle);
                FragmentManager manager = getActivity().getSupportFragmentManager();
                FragmentTransaction transaction = manager.beginTransaction();
                transaction.add(fragment, Comunes.TIME_PICKER);
                transaction.commit();
            }
        };
        texHora.setText(fechaHoraActual());

        btnhora.setOnClickListener(listenerHora);
        texHora.setOnClickListener(listenerHora);

        MetroSQLite m=new MetroSQLite(this.getContext() );
         lista = m.listaEstaciones();

        listadapter=new ArrayAdapter<String>(this.getContext(),
                R.layout.elemento_estacion2,
                R.id.titulo,
                lista);

        btnahora.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                String or = spinnerO.getSelectedItem().toString();
                String des = spinnerD.getSelectedItem().toString();
                String hor = texHora.getText().toString();
                Intent i = new Intent(v.getContext(), MuestraRuta.class);
                i.putExtra(Comunes.ORIGEN, or);
                i.putExtra(Comunes.DESTINO, des);
                i.putExtra(Comunes.HORA, hor);
                startActivity(i);
            }});

        btnhorarios.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                String or = spinnerO.getSelectedItem().toString();
                String des = spinnerD.getSelectedItem().toString();
                String hor = texHora.getText().toString();
                //HorariosRuta(or, des, hor);
                Intent i = new Intent(v.getContext(), MuestraHorariosTrip.class);
                i.putExtra(Comunes.ORIGEN, or);
                i.putExtra(Comunes.DESTINO, des);
                i.putExtra(Comunes.HORA, hor);
                startActivity(i);

            }
        });

            return v;
        }
        @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {


        spinnerO = (Spinner) view.findViewById(R.id.spinnerOrigen);
        spinnerO.setAdapter(listadapter);

        spinnerD = (Spinner) view.findViewById(R.id.spinnerDestino);
        spinnerD.setAdapter(listadapter);
        /*
        spinnerD.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {

                String deestino = lista.get(position);
                String Origen = spinnerO.getSelectedItem().toString();
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });
        */


    }
    public String fechaHoraActual(){
        return new SimpleDateFormat( "HH:mm", java.util.Locale.getDefault()).format(Calendar.getInstance() .getTime());
    }
    class MiHandlerHora extends Handler {
        @Override
        public void handleMessage(Message msg) {
            Bundle bundle = msg.getData();
            timeHour = bundle.getInt(Comunes.HOUR);
            timeMinute = bundle.getInt(Comunes.MINUTE);
            texHora.setText(timeHour + ":" + timeMinute);
        }
    }







}